unit CsucsMatrixAblak;
(*
  Lazarus v0.9.16 beta
*)

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Grids, Buttons;

type

  { TfmCsucsMatrix }

  TfmCsucsMatrix = class(TForm)
    bbVissza: TBitBtn;
    btFajlbol: TButton;
    btFajlba: TButton;
    edPontSzam: TEdit;
    lbCim: TLabel;
    lbPontSzam: TLabel;
    odBe: TOpenDialog;
    sdKi: TSaveDialog;
    sgCsucsMatrix: TStringGrid;
    procedure btFajlbaClick(Sender: TObject);
    procedure btFajlbolClick(Sender: TObject);
    procedure edPontSzamEditingDone(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  fmCsucsMatrix: TfmCsucsMatrix;

implementation

{ TfmCsucsMatrix }

uses
  FoAblak;

procedure TfmCsucsMatrix.edPontSzamEditingDone(Sender: TObject);
  var
    szam,siker,i,j:integer;
begin
  Val(edPontSzam.Text,szam,siker);
  if (siker<>0) or (szam<2) then
  begin
    edPontSzam.SetFocus;
    edPontSzam.Color:=clRed;
  end
    else
  begin
    edPontSzam.Color:=clWindow;
    PontDb:=szam;
    sgCsucsMatrix.RowCount:=szam+1; sgCsucsMatrix.ColCount:=szam+1;
    for i:=1 to szam do
    begin
      sgCsucsMatrix.Cells[0,i]:=intToStr(i);
      sgCsucsMatrix.Cells[i,0]:=intToStr(i);
    end;//for i
    for i:=1 to szam do
    begin
      for j:=1 to szam do
      begin
        sgCsucsMatrix.Cells[j,i]:='0';
      end;//for j
    end;//for i
  end;//if
end;//TfmCsucsMatrix.edPontSzamEditingDone

// Gombok esemnyei: ----------------------------------------------------------

procedure TfmCsucsMatrix.btFajlbolClick(Sender: TObject);
  var
    fBeN:string;
    fBe:TextFile;
    szam,i,j:integer;
begin
  if odBe.execute then
  begin
    fBeN:=odBe.FileName;
    assignFile(fBe,fBeN); reset(fBe);
    readln(fBe,PontDb);
    edPontSzam.Text:=intToStr(PontDb); edPontSzamEditingDone(Sender);
    for i:=1 to PontDb do
    begin
      for j:=1 to PontDb do
      begin
        read(fBe,szam);
        sgCsucsMatrix.Cells[j,i]:=intToStr(szam);
      end;//for j
      readln(fBe);
    end;//for i
    closeFile(fBe);
  end;//if odBe
end;//TfmCsucsMatrix.btFajlbolClick

procedure TfmCsucsMatrix.btFajlbaClick(Sender: TObject);
  var
    fKiN:string;
    fKi:TextFile;
    i,j:integer;
begin
  if sdKi.execute then
  begin
    fKiN:=sdKi.FileName;
    assignFile(fKi,fKiN); rewrite(fKi);
    writeln(fKi,PontDb);
    for i:=1 to PontDb do
    begin
      for j:=1 to PontDb do
      begin
        write(fKi,' '+sgCsucsMatrix.Cells[j,i]);
      end;//for j
      writeln(fKi);
    end;//for i
    closeFile(fKi);
  end;//if sdKi
end;//TfmCsucsMatrix.btFajlbaClick

initialization
  {$I csucsmatrixablak.lrs}

end.

